from sensor.Sensor import Sensor
from utils.datatypes import *
from utils import i18n

import os

#=====================================================================
# A Disk Mounter desklet
#=====================================================================
class DiskMount(Sensor):

    # Setup the Sensor
    def __init__(self, *args):

        global _; _ = i18n.Translator("diskmount-desklet")
        Sensor.__init__(self)

        #default config 
        self._set_config_type("path", TYPE_STRING, "/media/cdrom")
        self._set_config_type("id", TYPE_STRING, "cdrom")
        self._set_config_type("fontcolor", TYPE_STRING, "#FFFF00")
        self._set_config_type("update", TYPE_INT, 30)

        # start checking
        self._add_timer(1000, self.__check_mount_status)

    # is the drive mounted or not?
    def __check_mount_status(self):

        output = self._new_output()
        
        # check if it's unmounted...        
        command="mount | grep " + self._get_config("path") + " >& /dev/null"
        status = os.system(command);
  
        if (status == 0):
            print "Detected: MOUNTED"
            self.__mounted = 1
            output.set("mounted" % vars(), 1)
            output.set("unmounted" % vars(), 0)
        else:
            print "Detected: UNMOUNTED"
            self.__mounted = 0
            output.set("mounted" % vars(), 0)
            output.set("unmounted" % vars(), 1)
           

        output.set("font", "Courier 14")
        output.set("color", self._get_config("fontcolor"))
        output.set("id" %vars(), self._get_config("id"))
        output.set("x" %vars(), 30-((len(self._get_config("id"))*7.5)/2))
        self._send_output(output)

        # repeat in a while
        myupdate = int(self._get_config("update")) * 1000
        self._add_timer(myupdate, self.__check_mount_status)

 
    # override this ethod to enable user interaction
    def call_action(self, action, path, args = []):

        if (action == "mount"):
            if (self.__mounted):

                print "Unmounting Drive"
                command = "umount " + self._get_config("path")
                status = os.system(command)
 
                if (status == 0):
                    self.__mounted = 0
                    output = self._new_output()
                    output.set("mounted" % vars(), 0)
                    output.set("unmounted" % vars(), 1)
                    self._send_output(output)
            else:
                print "Mounting Drive"
                command = "mount " + self._get_config("path")
                status = os.system(command)

                if (status == 0):
                    self.__mounted = 1
                    output = self._new_output()
                    output.set("mounted" % vars(), 1)
                    output.set("unmounted" % vars(), 0)
                    self._send_output(output)
                
    # Add extra config fields
    def get_configurator(self):
 
        conf1 = self._new_configurator()
        conf1.set_name(_("DiskMount Settings"))
        conf1.add_title(_("Color of Desklet Font"))
        conf1.add_color_selector(_("Color"),"fontcolor", _("Color used in the title"))
        conf1.add_title(_("Mount Point"))
        conf1.add_entry(_("Path",), "path", _("The point where the device gets mounted"))
        conf1.add_title(_("Name of Device"))
        conf1.add_entry(_("Title",), "id", _("The name that gets displayed for the device"))
        conf1.add_title(_("Interval between updates (seconds)"))
        conf1.add_spin(_("Interval",), "update", _("The interval between updates (seconds)"),1,300) 

        return conf1

# Advertise the sensor
def new_sensor(args): return apply(DiskMount, args)

